-- button.lua
local Button = {}
Button.__index = Button

function Button:new(x, y, width, height, label)
    local btn = setmetatable({}, Button)
    btn.x = x
    btn.y = y
    btn.width = width
    btn.height = height
    btn.label = label
    btn.hovered = false
    btn.pressed = false
    return btn
end

function Button:isMouseOver()
    local mx, my = love.mouse.getPosition()
    return mx > self.x and mx < self.x + self.width and my > self.y and my < self.y + self.height
end

function Button:update()
    self.hovered = self:isMouseOver()
    if self.hovered and love.mouse.isDown(1) then
        self.pressed = true
    else
        self.ppressed = false
    end
end

function Button:draw()
    if self.pressed then
        love.graphics.setColor(0.8, 0.8, 0.8)
    elseif self.hovered then
        love.graphics.setColor(0.9, 0.9, 0.9)
    else
        love.graphics.setColor(1, 1, 1)
    end
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
    love.graphics.setColor(0, 0, 0)
    love.graphics.printf(self.label, self.x, self.y + self.height / 2 - 6, self.width, "center")
end

return Button
